<?php

/*
	$ Drag Now! v2.01  (C) 2005-2011 mfboy
	$ kernel.class.php
		+ 2011-07-19   2.01 汾, Ľύ֤ʽ
		+ 2011-07-13   SUBMIT ģʽύϢĴ
		+ 2011-07-09  ޸Ӧ 'index_top' Ƕİ
		+ 2011-07-06  ļʼд
*/

if(!defined('IN_DISCUZ')) {
	exit('Access Denied');
}

class plugin_dragnow_dzx {

	const MODE_NORMAL = 1;
	const MODE_LAYER = 2;
	const MODE_DEBUG = 3;
	const MODE_SUBMIT = 4;

	static private
		$initiated = FALSE,
		$cache, $mode, $extcredit;

	static public
		$CoreStatus, $CorePosition, $CoreModify, $CoreHide, $CoreUsergroup,
		$ExtType, $ExtNumber;

	public function __construct() {
		if(!self::$initiated) {
			self::_initVariable();
			self::_initRuntime();
		}
	}

	static private function _initExtcredit() {

		$ext = &$GLOBALS['_G']['setting']['extcredits'];
		$extcredit = array();

		if(isset($ext[self::$ExtType])) {
			$extcredit['id'] = self::$ExtType;
			$extcredit['need'] = self::$ExtNumber;
			$extcredit['title'] = $ext[self::$ExtType]['title'];
			$extcredit['unit'] = $ext[self::$ExtType]['unit'];
			$extcredit['mine'] = getuserprofile('extcredits'.self::$ExtType);
			$extcredit['str_mine'] = trim("{$extcredit[title]} {$extcredit[mine]} {$extcredit[unit]}");
			$extcredit['str_need'] = trim("{$extcredit[title]} ".self::$ExtNumber." {$extcredit[unit]}");
		} else {
			$extcredit['need'] = 0;
		}

		return $extcredit;

	}

	static private function _initMode() {

		global $_G;

		if(CURSCRIPT != 'forum' || CURMODULE != 'index') {
			return 0;
		} else if(empty($_G['uid']) || !empty($_G['gp_gid'])) {
			return 0;
		}

		if(self::$CoreStatus && in_array($_G['groupid'], self::$CoreUsergroup)) {
			$check = TRUE;
		} else {
			$check = FALSE;
		}

		if(isset($_G['gp_d']) && isset($_G['gp_f']) && $_G['gp_f'] == FORMHASH) {

			switch((int) $_G['gp_d']) {
				case self::MODE_LAYER:
					if($check) {
						return self::MODE_LAYER;
					}
					break;
				case self::MODE_SUBMIT:
					if($check && submitcheck('dsubmit')) {
						return self::MODE_SUBMIT;
					}
					break;
				case self::MODE_DEBUG:
					if($_G['adminid'] == 1) {
						return self::MODE_DEBUG;
					}
					break;
			}

		}

		if($check) {
			return self::MODE_NORMAL;
		} else {
			return 0;
		}

	}

	static private function _initRuntime() {

		self::$initiated = TRUE;
		self::$cache = DISCUZ_ROOT.'./data/dragnow/';
		self::$mode = self::_initMode();

		if(self::$mode == self::MODE_LAYER || self::$mode == self::MODE_SUBMIT) {
			self::$extcredit = self::_initExtcredit();
		}

	}

	static private function _initVariable() {

		loadcache('plugin');
		$vars = &$GLOBALS['_G']['cache']['plugin']['dragnow_dzx'];

		self::$CoreStatus = !empty($vars['CoreStatus']);
		self::$CorePosition = (int) $vars['CorePosition'];
		self::$CoreModify = !empty($vars['CoreModify']);
		self::$CoreHide = !empty($vars['CoreHide']);
		self::$CoreUsergroup = (array) @unserialize($vars['CoreUsergroup']);
		self::$ExtType = intval($vars['ExtType']);
		self::$ExtNumber = max(0, (int) $vars['ExtNumber']);

	}

	static protected function indexDraw($hookid) {

		$return = '';
		$position = self::$CorePosition;

		switch(self::$mode) {
			case self::MODE_NORMAL:
				include template('dragnow_dzx:normal');
				break;
			case self::MODE_DEBUG:
				include template('dragnow_dzx:debug');
				break;
		}

		return $return;

	}

	static protected function indexInit() {

		if(self::$mode) {
			$data = self::userLoad();
		} else {
			return;
		}

		switch(self::$mode) {
			case self::MODE_NORMAL:
				if($data) {
					self::indexHandleNormal($data);
				}
				break;
			case self::MODE_LAYER:
				self::indexHandleLayer($data);
				break;
			case self::MODE_SUBMIT:
				self::indexHandleSubmit();
				break;
		}

	}

	static private function indexHandleLayer(&$data) {

		global $catlist, $forumlist;

		$data = (array) $data;
		$hidden = $data ? TRUE : FALSE;

		$_catlist = $catlist;
		$catlist = array();

		foreach($data as $fup => $cate) {

			if(!isset($cate['forums']) || !isset($_catlist[$fup])) {
				continue;
			}

			$catlist[$fup] = $_catlist[$fup];
			$catlist[$fup]['dhidden'] = $cate['hidden'];
			$catlist[$fup]['dname'] = $cate['name'];
			$catlist[$fup]['dforums'] = array();

			foreach($cate['forums'] as $fid => $forum) {
				if(!isset($forumlist[$fid])) {
					continue;
				}
				$catlist[$fup]['dforums'][$fid] = array (
					'hidden' => $forum['hidden'],
					'name' => $forum['name']
				);
			}

			foreach($catlist[$fup]['forums'] as $fid) {
				if(!isset($catlist[$fup]['dforums'][$fid])) {
					$catlist[$fup]['dforums'][$fid] = array('hidden' => TRUE, 'name' => '');
				}
			}

			unset($_catlist[$fup]);

		}

		foreach($_catlist as $fup => $cate) {
			$catlist[$fup] = $cate;
			$catlist[$fup]['dhidden'] = $hidden;
			$catlist[$fup]['dforums'] = array();
			foreach($cate['forums'] as $fid) {
				$catlist[$fup]['dforums'][$fid] = array('hidden' => $hidden, 'name' => '');
			}
		}

		if($log = DB::fetch_first("SELECT dateline FROM ".DB::table('dragnow')." WHERE uid='".$GLOBALS['_G']['uid']."';")) {
			$lastdate = dgmdate($log['dateline']);
		} else {
			$lastdate = 0;
		}

		include template('dragnow_dzx:layer');
		exit;

	}

	static private function indexHandleNormal(&$data) {

		global $catlist, $forumlist;
		$data = (array) $data;

		$_catlist = $catlist;
		$catlist = array();

		foreach($data as $fup => $cate) {

			if(!isset($cate['forums']) || !isset($_catlist[$fup])) {
				continue;
			}
			if(isset($cate['hidden']) && $cate['hidden']) {
				continue;
			}

			$catlist[$fup] = $_catlist[$fup];
			$catlist[$fup]['forums'] = array();

			if(isset($cate['name']) && !empty($cate['name'])) {
				$catlist[$fup]['name'] = $cate['name'];
			}

			foreach($cate['forums'] as $fid => $forum) {
				if(!isset($forumlist[$fid])) {
					continue;
				}
				if(isset($forum['hidden']) && $forum['hidden']) {
					continue;
				}
				if(isset($forum['name']) && !empty($forum['name'])) {
					$forumlist[$fid]['name'] = $forum['name'];
				}
				$catlist[$fup]['forums'][] = $fid;
			}

		}

	}

	static private function indexHandleSubmit() {

		global $_G;

		$action = isset($_G['gp_do']) ? trim($_G['gp_do']) : '';
		$message = '';

		switch($action) {
			case 'default':
				self::userRemove();
				break;
			case 'save':
				$message = self::indexHandleSubmitSave();
				break;
			default:
				$message = 'undefined';
				break;
		}

		if($message) {
			$message = lang('plugin/dragnow_dzx', 'submit_'.$message);
			$message = str_replace('{0}', self::$extcredit['title'], $message);
		}

		include template('dragnow_dzx:submit');
		exit;

	}

	static private function indexHandleSubmitSave() {

		global $_G, $catlist, $forumlist;
		$data = $relates = array();

		$cates = (array) $_G['gp_cate'];
		$forums = (array) $_G['gp_forum'];

		foreach($forums as $string) {

			if(!($pos = strpos($string, '|'))) {
				continue;
			}

			@list($fid, $fup, $hidden) = explode(',', substr($string, 0, $pos));

			$fid = (int) $fid;
			$fup = (int) $fup;
			$hidden = (bool) $hidden;

			if(!isset($catlist[$fup]) || !isset($forumlist[$fid])) {
				continue;
			} else if(!in_array($fid, $catlist[$fup]['forums'])) {
				continue;
			}

			if(!self::$CoreHide) {
				$hidden = FALSE;
			}

			if(self::$CoreModify) {
				$name = htmlspecialchars(stripslashes(trim(substr($string, $pos + 1))));
			} else {
				$name = '';
			}

			$relates[$fup][$fid] = array ('hidden' => $hidden, 'name' => $name);

		}

		foreach($cates as $string) {

			if(!($pos = strpos($string, '|'))) {
				continue;
			}

			@list($fup, $hidden) = explode(',', substr($string, 0, $pos));

			$fup = (int) $fup;
			$hidden = (bool) $hidden;

			if(!isset($catlist[$fup])) {
				continue;
			}

			if(!self::$CoreHide) {
				$hidden = FALSE;
			}

			if(self::$CoreModify) {
				$name = htmlspecialchars(stripslashes(trim(substr($string, $pos + 1))));
			} else {
				$name = '';
			}

			$data[$fup] = array ('hidden' => $hidden, 'name' => $name, 'forums' => (array) $relates[$fup]);

		}

		if(self::$extcredit['need']) {
			if(self::$extcredit['mine'] < self::$extcredit['need']) {
				return 'extcredit';
			}
			updatemembercount($_G['uid'], array (self::$extcredit['id'] => '-'.self::$extcredit['need']), FALSE);
		}

		DB::insert('dragnow', array (
			'uid' => $_G['uid'],
			'setting' => addslashes(serialize($data)),
			'dateline' => TIMESTAMP), FALSE, TRUE);

		return (self::userUpdate() ? 'succeed' : 'failed');

	}

	static private function userHash($uid) {
		return ($uid % 10);
	}

	static private function userLoad($uid) {

		if(self::$mode == self::MODE_SUBMIT) {
			return NULL;
		}

		$uid = $GLOBALS['_G']['uid'];
		$data = array();

		@include_once self::$cache.self::userHash($uid).'/'.$uid.'.php';

		return $data;

	}

	static public function userRemove() {

		$uid = $GLOBALS['_G']['uid'];

		DB::delete('dragnow', array ('uid' => $uid));
		@unlink(self::$cache.self::userHash($uid).'/'.$uid.'.php');

	}

	static public function userUpdate() {

		$uid = $GLOBALS['_G']['uid'];
		$member = DB::fetch_first("SELECT setting FROM ".DB::table('dragnow')." WHERE uid='{$uid}';");

		if(!is_array($member) || !isset($member['setting'])) {
			return FALSE;
		}

		return self::userWrite($uid, (array) @unserialize($member['setting']));

	}

	static private function userWrite($uid, $data) {

		$dir = self::$cache.self::userHash($uid).'/';
		$file = $dir.$uid.'.php';

		if(!is_dir($dir)) {
			if(@mkdir($dir, 0777, TRUE)) {
				@fclose(fopen($dir.'index.htm', 'w'));
			} else {
				return FALSE;
			}
		}

		if(!$fp = @fopen($file, 'wb')) {
			return FALSE;
		}

		fwrite($fp, "<?php\n\n".
			"/*\n".
			"\t\$ Drag Now! v2.00  (C) 2005-2011 mfboy\n".
			"\t\$ {$uid}.php, {$uid}, ".gmdate('Y-m-d H:i:s')."\n".
			"*/\n\n".
			"if(!defined('IN_DISCUZ')) {\n".
			"\texit('Access Denied.');\n".
			"}\n\n".
			"\$data = ".var_export($data, TRUE).";\n\n".
			"?>");
		fclose($fp);

		return TRUE;

	}

}

?>