
/*
	$ Drag Now! v2.01  (C) 2005-2011 mfboy
	$ static/debug.js
		+ 2011-07-19   2.01 汾
		+ 2011-07-09  ƳǶ 'index_top' ļ
		+ 2011-07-07  ļʼд
*/

(function () {

	if(typeof window.d != 'object' || typeof window.d.lang != 'object') {
		return;
	} else if(typeof window.d.hash != 'string' || typeof window.d.position != 'number') {
		return;
	}

	var d = window.d;
	window.d = null;

	var x = {'start': $('d_start'), 'frame': $('d_frame'), 'suggest': $('d_suggest')},
		e = ['hook_status', 'hook_top', 'hook_middle'];

	switch(d.position) {
		case -1: e.push('el_dragnow'); break;
		case 1: e.push('el_pt'); break;
		case 2: e.push('el_ct'); break;
		case 3: e.push('el_chart'); break;
	}

	d.respond = function () {

		if(!x.start.disabled) {
			return;
		}

		var cw = x.frame.contentWindow;
		var sg = 'none';

		if(!cw || !cw.$) {
			d.show.invalid(null);
			return;
		}

		for(var i = 0; i < e.length; i++) {
			if(e[i].substr(0, 5) == 'hook_') {
				var id = 'd_' + e[i];
			} else {
				var id = e[i].substr(3);
			}
			if(cw.$(id)) {
				d.show.succeed(e[i]);
			} else {
				d.show.missing(e[i]);
			}
		}

		switch(d.position) {
			case -1:
				sg = 'custom';
				break;
			case 1:
				if(cw.$('an')) {
					sg = 'annouce';
				}
				break;
		}

		$('d_suggest').innerHTML = d.lang.suggest[sg];
		x.start.disabled = false;

	};

	d.show = {
		'_output': function (id, status) {
			if(typeof id == 'string') {
				$('d_item_' + id).innerHTML = d.lang.result[status];
			} else {
				for(var i = 0; i < e.length; i++) {
					$('d_item_' + e[i]).innerHTML = d.lang.result[status];
				}
			}
		},
		'invalid': function (id) {
			d.show._output(id, 'invalid');
		},
		'loading': function () {
			d.show._output(null, 'loading');
		},
		'missing': function (id) {
			d.show._output(id, 'missing');
		},
		'succeed': function (id) {
			d.show._output(id, 'succeed');
		}
	};

	if(BROWSER.ie && BROWSER.ie < '9.0') {
		x.frame.onreadystatechange = function () {
			if(x.frame.readyState == 'complete') {
				d.respond();
			}
		};
	} else {
		x.frame.onload = d.respond;
	}

	x.start.onclick = function () {
		d.show.loading();
		x.start.disabled = true;
		x.frame.src = 'forum.php?d=3&f=' + d.hash + '&s=' + Math.random();
	};

})();
